#include <bits/stdc++.h>
using namespace std;
const int MOD = 1000000007;

int count_colorings(const vector< vector<int> > &G, int C) {
    vector< vector<int> > comb(C+1);
    for (int c=0; c<=C; ++c) {
        comb[c].resize(c+1,1);
        for (int k=1; k<c; ++k) comb[c][k] = ( comb[c-1][k-1] + comb[c-1][k] ) % MOD;
    }

    int N = G.size();
    //cerr << "component of size " << N << endl;

    unordered_set<int> sparse_sets;
    sparse_sets.insert(0);
    while (true) {
        unordered_set<int> new_sparse_sets = sparse_sets;
        for (int s : sparse_sets) for (int n=0; n<N; ++n) {
            bool can_add = true;
            for (int i=0; i<N; ++i) if (s & 1<<i) if (G[n][i] <= 2) { can_add = false; break; }
            if (can_add) new_sparse_sets.insert(s ^ 1<<n);
        }
        if (sparse_sets == new_sparse_sets) break;
        sparse_sets = new_sparse_sets;
    }
    sparse_sets.erase(0);

    vector< vector<int> > dp(N+1, vector<int>(1<<N,0) );
    dp[0][0] = 1;
    for (int colored=1; colored<(1<<N); ++colored) {
        for (int s : sparse_sets) if ((colored & s) == s) {
            for (int c=1; c<=N; ++c) {
                dp[c][colored] += dp[c-1][colored ^ s];
                if (dp[c][colored] >= MOD) dp[c][colored] -= MOD;
            }
        }
    }
    long long answer = 0;
    for (int c=1; c<=min(N,C); ++c) { answer += 1LL * comb[C][c] * dp[c][(1<<N)-1]; answer %= MOD; }
    return (int) answer;
}

int main() {
    int N, M, C;
    cin >> N >> M >> C;

    vector< vector<int> > G( N, vector<int>(N,987654321) );
    for (int m=0; m<M; ++m) {
        int x, y;
        cin >> x >> y;
        G[x][y] = G[y][x] = 1;
    }
    for (int n=0; n<N; ++n) G[n][n] = 0;
    for (int k=0; k<N; ++k) for (int i=0; i<N; ++i) for (int j=0; j<N; ++j) G[i][j] = min( G[i][j], G[i][k]+G[k][j] );

    long long answer = 1;
    vector<bool> done(N,false);
    for (int n=0; n<N; ++n) if (!done[n]) {
        vector<int> komponent;
        for (int a=0; a<N; ++a) if (G[a][n] < 987654321) { komponent.push_back(a); done[a] = true; }
        int NK = komponent.size();
        vector< vector<int> > GK(NK, vector<int>(NK));
        for (int a=0; a<NK; ++a) for (int b=0; b<NK; ++b) GK[a][b] = G[komponent[a]][komponent[b]];
        answer *= count_colorings(GK,C);
        answer %= MOD;
    }
    cout << answer << endl;
}
